//{*******************************************************}
//{                                                       }
//{             .black - RAGE research project            }
//{                 Copyright(c) 2008-2011                }
//{                                                       }
//{                                                       }
//{   If you have any suggestions how improve this code   }
//{   please contact us on our web site                   }
//{                                  http://openiv.com/   }
//{                                                       }
//{*******************************************************}


// Parameters:
float4x4 gWorld;			
float4x4 gView;
float4x4 gProj;
float3 gColor = float3( 0, 0, 0 );
float gScale = 0.25;
float gZOffset = 1.0f;

// Vertex shader input structure
struct VS_INPUT
{
	float3 Position : POSITION; 
};

// Vertex shader output structure
struct VS_OUTPUT
{
	float4 Position : POSITION;
	float Size : PSIZE;
};

// Vertex shader
VS_OUTPUT VShader( VS_INPUT input )
{
    VS_OUTPUT output;
    
    float4 worldPosition = mul( float4(input.Position, 1.0f), gWorld );
    float4 viewPosition = mul(worldPosition, gView);
    output.Position = mul(viewPosition, gProj);
                
    if (gZOffset > 0.99) {
		output.Position.z -= 1.0e-3;
	}
    output.Size = 4.0f; 

    return output;    
}

// Pixel shader output structure
struct PS_OUTPUT
{
    float4 Color : COLOR0;  // Pixel color    
};

// Trivial pixel shader
PS_OUTPUT PShader( ) 
{ 
    PS_OUTPUT output;    
	output.Color = float4( gColor, 1.0f );
    return output;
}

// Techniques:
technique Draw
{
    pass P0
    {   
		CullMode=None; 
		ZWriteEnable=false;
        PointScaleEnable=false;
        VertexShader = compile vs_2_0 VShader();
        PixelShader  = compile ps_2_0 PShader(); 
    }
}